<template>
  <div>
    <div
      class="stickySearchGameFilter relative"
      :class="{ 'main-entry-container': isMain }"
    >
      <div
        v-if="isLoading"
        class="absolute top-[106px] w-full bg-background2 z-[2] flex justify-center py-4"
      >
        <circular-loading />
      </div>
      <div class="flex overflow-auto px-4 items-center bg-1">
        <form class="relative" @submit.prevent="updateSearchResult">
          <el-input
            v-model="searchModel"
            class="w-full mr-2 flex-auto game-search-input"
            :class="{ 'main-tool-tip-trigger': isMain }"
            :placeholder="$t('Search All Games')"
            :suffix-icon="Search"
            type="search"
            @input="searching"
          >
          </el-input>
          <el-button
            class="absolute right-0 top-0 rounded-l-none"
            style="padding: 0.5rem; height: 40px; border-radius: 0 8px 8px 0"
            type="primary"
            native-type="submit"
          >
            <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
          </el-button>
        </form>
        <template v-for="tab in headerTab" :key="tab">
          <el-select
            v-if="tab === 'Provider'"
            v-model="providerModel"
            popper-class="dropdown-width"
            class="p-2 pr-0"
            :class="{ 'main-tool-tip-trigger': isMain }"
            :placeholder="$t('provider')"
          >
            <el-option
              v-for="provider in providers"
              :key="provider"
              :class="`${
                subTabInitial === provider.ProviderName && !searchModel
                  ? 'border-b selected selected-icon'
                  : 'fc-text'
              } ${
                provider.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              } ${isMain ? 'main-dropdown' : ''}`"
              :value="provider.GameProviderDisplayName"
              @click="onGameTabClicked(tab, provider.ProviderName)"
            >
              <div class="flex justify-between w-full">
                <div>
                  <div class="flex items-center">
                    <div>
                      {{ provider.GameProviderDisplayName }}
                    </div>
                    <div
                      v-if="provider.isNewProvider"
                      class="ml-3 px-2 py-0 h-[1rem] rounded-md text-xs text-white"
                    >
                      <img
                        class="w-[48px] h-[16px] object-contain"
                        :src="
                          getAssetImage('assets/theme/common/icon/new_icon.svg')
                        "
                      />
                    </div>
                    <div
                      v-if="provider.HasPromoGame"
                      class="ml-3 px-2 py-0 h-[1rem] rounded-md text-xs bg-blue-500 text-white"
                    >
                      Promo
                    </div>
                    <div
                      v-if="!isMain"
                      class="w-[16px] ml-[11px]"
                      :class="
                        subTabInitial === provider.ProviderName
                          ? 'block'
                          : 'hidden'
                      "
                    >
                      <font-awesome-icon icon="circle-check" />
                    </div>
                  </div>
                </div>
                <div
                  v-if="isMain"
                  class="w-[16px] ml-[11px]"
                  :class="
                    subTabInitial === provider.ProviderName ? 'block' : 'hidden'
                  "
                >
                  <font-awesome-icon icon="circle-check" />
                </div>
              </div>
            </el-option>
          </el-select>
        </template>
      </div>
      <div
        ref="gameTypeContainerRef"
        class="flex py-2 overflow-auto bg-1 px-4 hideScrollbar"
      >
        <template v-for="tab in headerTab" :key="tab">
          <div
            v-if="tab !== 'Game Type' && tab !== 'Provider'"
            @click="onGameTabClicked(tab)"
          >
            <div
              class="game-type-item p-2 cursor-pointer whitespace-nowrap"
              :class="{
                'border-b-[3px] selected border-selected':
                  tabInitial === tab && !searchModel,
              }"
            >
              <div class="flex items-center">
                <div class="text-sm font-normal leading-4">
                  {{ $t(tab.replace(" ", "_").toLowerCase()) }}
                </div>
              </div>
            </div>
          </div>
        </template>
        <div
          v-for="gameType in gameTypes"
          :key="gameType"
          @click="onGameTabClicked('Game Type', gameType)"
        >
          <div
            class="game-type-item p-2 cursor-pointer whitespace-nowrap"
            :class="{
              'border-b selected border-selected':
                subTabInitial === gameType && !searchModel,
            }"
          >
            <div class="flex items-center">
              <div class="text-sm font-normal leading-4">
                {{ $t(gameType.toLowerCase()) }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      class="p-4 bg-1 game-list-content relative"
      :class="{ 'main-entry-container': isMain }"
    >
      <div
        v-if="isLoading"
        class="absolute top-0 w-full h-full bg-background2 z-[1]"
      ></div>
      <div class="game-entry-list-main transition">
        <div
          v-for="init in gameReadyToRender"
          :key="init.GameId"
          class="relative w-full aspect-square game_card"
          :class="init.IsNewGame ? '' : init.IsPromotionGame ? '' : ''"
          @click="
            authenticated
              ? handleGameEntryOpenWindow(init, 550, 850)
              : toggleLoginRegisterDialog()
          "
        >
          <SharedGameTags
            class="absolute top-1 left-1"
            :is-hot="init.IsHotGame"
            :is-new="init.IsNewGame"
            width="32px"
          />
          <SharedButtonFavorite
            v-if="!useIsDesktop()"
            :game="init"
            class="absolute top-1 right-1"
          />
          <IconFavorite
            v-else
            :game-data="init"
            :check-is-favourite="checkIsFavourite"
            :redirect-to-login="redirectToLogin"
            :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
            :toggle-dialog="true"
          />
          <div class="w-full h-full">
            <img
              :src="isImageVersionExist(init.GameIconUrl)"
              class="object-contain w-full h-full rounded-lg"
            />
          </div>
        </div>
        <span
          v-if="!initialGameEntry.length && !isLoading"
          class="w-full text-center place-content-center pt-24"
        >
          {{ $t("no_data") }}
        </span>
      </div>
      <div ref="loadingMoreRef" class="w-full text-center"></div>
    </div>
    <el-backtop :right="30" :bottom="30">
      <div class="w-[35px] h-[35px] flex items-center justify-center">
        <font-awesome-icon icon="arrow-up" class="text-black" />
      </div>
    </el-backtop>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, ref, watch } from "vue";
import { Search } from "@element-plus/icons-vue";
import {
  handleGameEntryOpenWindow,
  useGameEntryComponent,
} from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";

export default defineComponent({
  name: "MGameEntryComponent",
  components: { Search },
  setup() {
    const { getAssetImage, toggleLoginRegisterDialog } = commonHelper;
    const providerModel = ref<string>();
    const preProviderModel = ref<string>();
    const gameTypeContainerRef = ref();
    const {
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      searchedGame,
      tabInitial,
      subTabInitial,
      authenticated,
      handleSearchGame,
      handleSelectedTabOption,
      updateSearchResult,
      gameCollection,
    } = useGameEntryComponent();
    const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
      useAddToFavorite();
    const loadingMoreRef = ref();
    const isScrollOver = ref(true);
    const marginTopInitialGameEntry = ref(0);
    const searchModel = ref(searchedGame.value);
    // let timeout: any = null;
    const searching = (e: any) => {
      // clearTimeout(timeout);
      // timeout = setTimeout(() => {
      if (e) {
        preProviderModel.value = providerModel.value;
        providerModel.value = "";
      } else {
        providerModel.value = preProviderModel.value;
        updateSearchResult();
      }
      searchedGame.value = searchModel.value;
      handleSearchGame();
      // }, 800);
    };
    const onGameTabClicked = (segment: string, selected?: string) => {
      searchModel.value = "";
      // searchedGame.value = "";
      handleSelectedTabOption(segment, selected);
    };
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const isMain = computed(() => store.state.selectedThemeName === "main");
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (gameCollection.value !== undefined) {
        for (let i = 0; i < gameCollection.value.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = gameCollection.value.slice(
            i,
            i + chunkSize
          );
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    const { convertString } = textHelper;
    const getProviderLogo = (providerName: string): string => {
      try {
        const fileName = `provider_logo_${convertString(
          providerName,
          true
        )}.png`;
        return getAssetImage(
          `assets/theme/bk8/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const isSeachGameFocus = ref(false);

    /**
     * Preventing body scroll when games is fetching
     * This will take effect only Layout V2.
     */
    watch(isLoading, (value) => {
      useToggleBodyOverflow(!value);
    });

    let loadMoreTimeout: NodeJS.Timeout;
    const observer = new IntersectionObserver(
      (entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            clearTimeout(loadMoreTimeout);
            loadMoreTimeout = setTimeout(() => {
              gameLoading();
            }, 100);
          }
        });
      },
      {
        root: null,
        threshold: 0.5,
      }
    );

    watch(
      loadingMoreRef,
      () => {
        if (loadingMoreRef.value) {
          observer.observe(loadingMoreRef.value);
        }
      },
      {
        immediate: true,
      }
    );

    watch(gameTypeContainerRef, () => {
      setTimeout(() => {
        const selectedGameTypeItem = gameTypeContainerRef.value.querySelector(
          ".game-type-item.selected"
        );
        if (selectedGameTypeItem) {
          selectedGameTypeItem.scrollIntoView({
            behavior: "smooth",
            block: "nearest",
          });
        }
      }, 100);
    });

    return {
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      tabInitial,
      providerModel,
      subTabInitial,
      authenticated,
      handleSelectedTabOption,
      handleGameEntryOpenWindow,
      commonHelper,
      isScrollOver,
      marginTopInitialGameEntry,
      getAssetImage,
      searchModel,
      searching,
      gameLoading,
      gameReadyToRender,
      isImageVersionExist,
      getProviderLogo,
      isSeachGameFocus,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
      toggleLoginRegisterDialog,
      onGameTabClicked,
      updateSearchResult,
      gameCollection,
      isMain,
      loadingMoreRef,
      gameTypeContainerRef,
    };
  },
});
</script>
<style lang="postcss" scoped>
:deep(.el-input--default.flex-auto > input.el-input__inner) {
  width: 100%;
}
:deep(.el-input .el-input__inner) {
  height: 40px !important;
  border-radius: 8px;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}
:deep(.el-select .el-input__inner) {
  width: 100%;
  border-radius: 8px;
}
.game_card {
  background: #1f2141;
  border-radius: 8px;
}
.before__content {
  @apply before:absolute before:top-0 before:px-[7px] before:py-[3px] before:rounded-tl-lg before:rounded-br-lg before:text-white  rounded-lg;
}
.before__new__content {
  @apply before:content-['NEW'] before:bg-[#31c46e];
}
.before__promo__content {
  @apply before:content-['PROMOTION'] before:bg-[#e63964];
}
.icon-custom-position {
  object-position: 50% -1px;
}
.selected-icon-custom-position {
  object-position: 50% -21px;
}
.el-select-dropdown__item.selected {
  color: var(--hint);
  border: none;
}
.bg-1 {
  background-color: rgb(5, 7, 30);
}
.bg-2 {
  background-color: rgb(31, 33, 65);
}
.border-selected {
  border-bottom: 2px solid var(--hint);
}
.selected-icon {
  display: block;
}
:deep(.el-input__inner) {
  background-color: rgb(31, 33, 65);
  font-size: 14px;
  height: 40px !important;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
.btn-selected {
  opacity: 1;
  border: 1px solid var(--primary) !important;
}
.opacity {
  opacity: 1;
}
.border {
  border: 1px solid var(--border);
}
.el-select-dropdown__item {
  padding-left: 8px;
}
:deep(.el-input--prefix .el-input__inner) {
  padding-left: 45px;
}
.game_card {
  border: 1px solid var(--border);
}
</style>
<style>
[layout="black_flexible_mobile_1"] .el-carousel {
  z-index: 10;
}
[theme-color="bk8"] .bg-1 {
  background-color: white;
}
[theme-color="bk8"] .el-input__inner {
  background-color: var(--background1);
  color: var(--text) !important;
}
.search span.el-input__suffix {
  display: flex;
  align-items: center;
  color: var(--el-input-icon-color, var(--el-text-color-placeholder));
}
.game-entry-list-main {
  /* grid grid-cols-3 gap-2 */
  display: flex;
  flex-wrap: wrap;
  gap: 8px 8px;
  width: 100%;
}
.game-entry-list-main > div {
  width: calc((100% / 3) - 6px);
}
.dropdown-width {
  width: 82%;
  left: 40px !important;
}
.el-popper.is-pure.is-light.el-select__popper.dropdown-width {
  border: 1px solid var(--border) !important;
}
</style>
<style lang="scss" scoped>
.hideScrollbar::-webkit-scrollbar {
  display: none;
}
.fixedSearchGameFilter + .game-list-content {
  margin-top: 88px;
}

.game-search-input :deep(.el-input__inner) {
  padding-right: 2.75rem;
}
.game-search-input
  :deep(.el-input__inner[type="search"]::-webkit-search-cancel-button) {
  -webkit-appearance: none;
  appearance: none;
  display: none;
}
</style>
<style lang="scss">
.main-tool-tip-trigger {
  .el-input__inner {
    background: var(--background5);
  }
}
.el-select__popper:has(.main-dropdown) {
  left: 16px !important;
  width: calc(100vw - 32px);
  overflow-y: scroll;
  background: var(--background5) !important;
  .main-entry-container {
    max-height: 320px;
  }
  .el-select-dropdown {
    width: 100%;
    .main-dropdown {
      padding-left: 16px;
      padding-right: 16px;
    }
  }
}
.main-entry-container {
  background-color: var(--background2) !important;
  > div {
    background-color: var(--background2) !important;
  }
}
[theme-color="global_light_01"] {
  .bg-1 {
    background: var(--background2);
  }
  .el-select .el-input__inner,
  .el-input__inner {
    background: var(--background5);
    color: var(--text5);
  }
}
</style>
